{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#generate.cwl/nevents"
                },
                {
                    "type": "string",
                    "id": "#generate.cwl/type"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/generantuple.py $(inputs.type) $(inputs.nevents) output_one.root\n",
                    "prefix": "-c"
                }
            ],
            "id": "#generate.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "output_one.root"
                    },
                    "id": "#generate.cwl/events"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#histogram.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#histogram.cwl/name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "nominal"
                    ],
                    "id": "#histogram.cwl/variations"
                },
                {
                    "type": "float",
                    "id": "#histogram.cwl/weight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hist.root"
                    },
                    "id": "#histogram.cwl/histogram"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/histogram.py $(inputs.inputfile.path) hist.root $(inputs.name) $(inputs.weight) ${\n  var list=\"\";\n  var variationsLength = inputs.variations.length;\n  console.log(variationsLength);\n  for (var i = 0; i < variationsLength; i++) {\n    list += inputs.variations[i];\n    if (i < variationsLength - 1) {\n      list = list +\",\";\n    }\n  }\n  return list; }\n"
                }
            ],
            "id": "#histogram.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#histogram_shape.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#histogram_shape.cwl/name"
                },
                {
                    "type": "string",
                    "id": "#histogram_shape.cwl/shapevar"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#histogram_shape.cwl/variations"
                },
                {
                    "type": "float",
                    "id": "#histogram_shape.cwl/weight"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "hist.root"
                    },
                    "id": "#histogram_shape.cwl/histogram"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/histogram.py $(inputs.inputfile.path) hist.root $(inputs.name)_$(inputs.shapevar) $(inputs.weight) ${\n  var list=\"\";\n  var variationsLength = inputs.variations.length;\n  console.log(variationsLength);\n  for (var i = 0; i < variationsLength; i++) {\n    list += inputs.variations[i];\n    if (i < variationsLength - 1) {\n      list = list +\",\";\n    }\n  }\n  return list; } {name}\n"
                }
            ],
            "id": "#histogram_shape.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "listing": [
                        {
                            "entryname": "input_list",
                            "entry": "${ var list = \"\";\n   inputs.histograms.forEach(function(value)  {\n     list += value.path + '\\n';\n     });\n   return list; }\n"
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#merge.cwl/histograms"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "merged.root"
                    },
                    "id": "#merge.cwl/merged"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "valueFrom": "source /usr/local/bin/thisroot.sh\ncat $(runtime.outdir)/input_list | xargs hadd merged.root\n",
                    "prefix": "-c"
                }
            ],
            "id": "#merge.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "dockerPull": "lukasheinrich/dummyanalysis",
                    "class": "DockerRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#select.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#select.cwl/region"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#select.cwl/variations"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "selection.root"
                    },
                    "id": "#select.cwl/outputfile"
                }
            ],
            "baseCommand": "/bin/bash",
            "arguments": [
                {
                    "prefix": "-c",
                    "valueFrom": "source /usr/local/bin/thisroot.sh\npython /code/select.py $(inputs.inputfile.path) selection.root $(inputs.region) ${\n   var list=\"\";\n   var variationsLength = inputs.variations.length;\n   console.log(variationsLength);\n   for (var i = 0; i < variationsLength; i++) {\n     list += inputs.variations[i];\n     if (i < variationsLength - 1) {\n       list = list +\",\";\n     }\n   }\n   return list; }\n"
                }
            ],
            "id": "#select.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/mcnames"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "float"
                    },
                    "id": "#main/mcweights"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#main/nevents"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "shape_conv_up",
                        "shape_conv_dn"
                    ],
                    "id": "#main/shapevars"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "nominal",
                        "weight_var1_up",
                        "weight_var1_dn"
                    ],
                    "id": "#main/weightvariations"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/merge/merged",
                    "id": "#main/merged"
                }
            ],
            "steps": [
                {
                    "run": "#merge.cwl",
                    "in": [
                        {
                            "source": "#main/run_mc/merged",
                            "id": "#main/merge/histograms"
                        }
                    ],
                    "out": [
                        "#main/merge/merged"
                    ],
                    "id": "#main/merge"
                },
                {
                    "run": "#workflow_mc.cwl",
                    "in": [
                        {
                            "source": "#main/mcnames",
                            "id": "#main/run_mc/mcname"
                        },
                        {
                            "source": "#main/mcweights",
                            "id": "#main/run_mc/mcweight"
                        },
                        {
                            "source": "#main/nevents",
                            "id": "#main/run_mc/nevents"
                        },
                        {
                            "source": "#main/shapevars",
                            "id": "#main/run_mc/shapevars"
                        },
                        {
                            "source": "#main/weightvariations",
                            "id": "#main/run_mc/weightvariations"
                        }
                    ],
                    "scatter": [
                        "#main/run_mc/mcname",
                        "#main/run_mc/mcweight"
                    ],
                    "scatterMethod": "dotproduct",
                    "out": [
                        "#main/run_mc/merged"
                    ],
                    "id": "#main/run_mc"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#workflow_mc.cwl/mcname"
                },
                {
                    "type": "float",
                    "id": "#workflow_mc.cwl/mcweight"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "id": "#workflow_mc.cwl/nevents"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#workflow_mc.cwl/shapevars"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#workflow_mc.cwl/weightvariations"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#workflow_mc.cwl/merge_all_vars/merged",
                    "id": "#workflow_mc.cwl/merged"
                }
            ],
            "steps": [
                {
                    "run": "#merge.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/read/events",
                            "id": "#workflow_mc.cwl/merge/histograms"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/merge/merged"
                    ],
                    "id": "#workflow_mc.cwl/merge"
                },
                {
                    "run": "#merge.cwl",
                    "in": [
                        {
                            "source": [
                                "#workflow_mc.cwl/select_signal_hist/histogram",
                                "#workflow_mc.cwl/merge_shape/merged"
                            ],
                            "id": "#workflow_mc.cwl/merge_all_vars/histograms"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/merge_all_vars/merged"
                    ],
                    "id": "#workflow_mc.cwl/merge_all_vars"
                },
                {
                    "run": "#merge.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/select_signal_shapevars/histogram",
                            "id": "#workflow_mc.cwl/merge_shape/histograms"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/merge_shape/merged"
                    ],
                    "id": "#workflow_mc.cwl/merge_shape"
                },
                {
                    "run": "#generate.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/nevents",
                            "id": "#workflow_mc.cwl/read/nevents"
                        },
                        {
                            "source": "#workflow_mc.cwl/mcname",
                            "id": "#workflow_mc.cwl/read/type"
                        }
                    ],
                    "scatter": "#workflow_mc.cwl/read/nevents",
                    "out": [
                        "#workflow_mc.cwl/read/events"
                    ],
                    "id": "#workflow_mc.cwl/read"
                },
                {
                    "run": "#select.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/merge/merged",
                            "id": "#workflow_mc.cwl/select_signal/inputfile"
                        },
                        {
                            "default": "signal",
                            "id": "#workflow_mc.cwl/select_signal/region"
                        },
                        {
                            "source": "#workflow_mc.cwl/weightvariations",
                            "id": "#workflow_mc.cwl/select_signal/variations"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/select_signal/outputfile"
                    ],
                    "id": "#workflow_mc.cwl/select_signal"
                },
                {
                    "run": "#histogram.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/select_signal/outputfile",
                            "id": "#workflow_mc.cwl/select_signal_hist/inputfile"
                        },
                        {
                            "source": "#workflow_mc.cwl/mcname",
                            "id": "#workflow_mc.cwl/select_signal_hist/name"
                        },
                        {
                            "source": "#workflow_mc.cwl/weightvariations",
                            "id": "#workflow_mc.cwl/select_signal_hist/variations"
                        },
                        {
                            "source": "#workflow_mc.cwl/mcweight",
                            "id": "#workflow_mc.cwl/select_signal_hist/weight"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/select_signal_hist/histogram"
                    ],
                    "id": "#workflow_mc.cwl/select_signal_hist"
                },
                {
                    "run": "#workflow_select_shape.cwl",
                    "in": [
                        {
                            "source": "#workflow_mc.cwl/merge/merged",
                            "id": "#workflow_mc.cwl/select_signal_shapevars/inputfile"
                        },
                        {
                            "source": "#workflow_mc.cwl/mcname",
                            "id": "#workflow_mc.cwl/select_signal_shapevars/mcname"
                        },
                        {
                            "source": "#workflow_mc.cwl/mcweight",
                            "id": "#workflow_mc.cwl/select_signal_shapevars/mcweight"
                        },
                        {
                            "source": "#workflow_mc.cwl/shapevars",
                            "id": "#workflow_mc.cwl/select_signal_shapevars/shapevar"
                        }
                    ],
                    "out": [
                        "#workflow_mc.cwl/select_signal_shapevars/histogram"
                    ],
                    "scatter": "#workflow_mc.cwl/select_signal_shapevars/shapevar",
                    "id": "#workflow_mc.cwl/select_signal_shapevars"
                }
            ],
            "id": "#workflow_mc.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#workflow_select_shape.cwl/inputfile"
                },
                {
                    "type": "string",
                    "id": "#workflow_select_shape.cwl/mcname"
                },
                {
                    "type": "float",
                    "id": "#workflow_select_shape.cwl/mcweight"
                },
                {
                    "type": "string",
                    "id": "#workflow_select_shape.cwl/shapevar"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#workflow_select_shape.cwl/hist/histogram",
                    "id": "#workflow_select_shape.cwl/histogram"
                }
            ],
            "steps": [
                {
                    "run": "#histogram_shape.cwl",
                    "in": [
                        {
                            "source": "#workflow_select_shape.cwl/select/outputfile",
                            "id": "#workflow_select_shape.cwl/hist/inputfile"
                        },
                        {
                            "source": "#workflow_select_shape.cwl/mcname",
                            "id": "#workflow_select_shape.cwl/hist/name"
                        },
                        {
                            "source": "#workflow_select_shape.cwl/shapevar",
                            "id": "#workflow_select_shape.cwl/hist/shapevar"
                        },
                        {
                            "default": [
                                "nominal"
                            ],
                            "id": "#workflow_select_shape.cwl/hist/variations"
                        },
                        {
                            "source": "#workflow_select_shape.cwl/mcweight",
                            "id": "#workflow_select_shape.cwl/hist/weight"
                        }
                    ],
                    "out": [
                        "#workflow_select_shape.cwl/hist/histogram"
                    ],
                    "id": "#workflow_select_shape.cwl/hist"
                },
                {
                    "run": "#select.cwl",
                    "in": [
                        {
                            "source": "#workflow_select_shape.cwl/inputfile",
                            "id": "#workflow_select_shape.cwl/select/inputfile"
                        },
                        {
                            "default": "signal",
                            "id": "#workflow_select_shape.cwl/select/region"
                        },
                        {
                            "source": "#workflow_select_shape.cwl/shapevar",
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#workflow_select_shape.cwl/select/variations"
                        }
                    ],
                    "out": [
                        "#workflow_select_shape.cwl/select/outputfile"
                    ],
                    "id": "#workflow_select_shape.cwl/select"
                }
            ],
            "id": "#workflow_select_shape.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
